//
// C++ Implementation: pluginsettingsdlg
//
// Description: 
//
//
// Author: Benjamin Mesing <bensmail@gmx.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include <qlayout.h>
#include <qtabwidget.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <QVBoxLayout>
#include <QHBoxLayout>


#include "pluginsettingsdlg.h"

#include "plugincontainer.h"


namespace NPlugin 
{

PluginSettingsDlg::PluginSettingsDlg(QWidget *parent, const char *name)
 : QDialog(parent)
{
	setObjectName(name);
	setupUi(this);
	// removve main tab, because it is currently not used
	_pSettingsTabWidget->removeTab(0);
}


PluginSettingsDlg::~PluginSettingsDlg()
{
}

void PluginSettingsDlg::addPlugin(PluginContainer* pPluginContainer)
{
//	_pPluginWidget->addTab( new QLabel("test", _pPluginWidget), pPluginContainer->title() );
	QWidget* pSettingsWidget = pPluginContainer->getSettingsWidget(this);
	if (pSettingsWidget != 0)
	{
		_pSettingsTabWidget->addTab(pSettingsWidget, pPluginContainer->title());
	}
}



};
